import 'dart:async';
import 'package:flutter/services.dart';
import 'package:shareintentinterface/ShareIntentInterface.dart';

// The method channel to interact with the native platform.
const MethodChannel _channel = MethodChannel('plugins.flutter.io/shareintent');

// The event channel to receive shared link changes / new shared links.
EventChannel eventChannel = EventChannel('plugins.flutter.io/shareintent_status');

Stream<String> _onLinkShare;

class ShareIntentMethodChannel extends ShareIntentPlatform {

  @override
  Stream<String> get onShareIntentReceived {
    if (_onLinkShare == null) {
      _onLinkShare = eventChannel
          .receiveBroadcastStream()
          .map((dynamic result) => result.toString());
    }
    return _onLinkShare;
  }

  @override
  Future<String> getSharedContent() {
    return _channel.invokeMethod<String>('shareIntent');
  }
}
